Option Explicit

'- Drive Informatie ------------------------------------
Dim objFSO
Dim Drv
Dim Dname
Dim Dfree
Dim Dtot
Dim Dpct
Dim Dused
Dim Dinfo

'- Memory ----------------------------------------------
Dim MemObject
'Dim TotalPhysicalMem
'Dim FreePhysicalMem
Dim TotalPageMem
Dim FreePageMem
Dim UsedPageMem

'- UpTime ----------------------------------------------
Dim OSObject
Dim Bootup
Dim LastBootupTime
Dim SystemUptime
Dim HBStartTime
Dim HouseBotStartTime
Dim HouseBotUpTime

'- IP & Hostname ---------------------------------------
Const cstrShowMyIP = "http://www.showmyip.com/xml/"
Dim objRemXML
Dim objMyIP
Dim strIPAddress
Dim strHostname


'-------------------------------------------------------
'- Drive Info ------------------------------------------
'-------------------------------------------------------
Set objFSO = CreateObject("Scripting.FileSystemObject")

For each Drv in objFSO.Drives
	Select Case Drv.DriveType
		Case 2:	Dfree = Round(Drv.FreeSpace / (1024 ^ 3), 1) & " GB"
			Dtot  = Round(Drv.TotalSize / (1024 ^ 3), 1) & " GB"
			Dused = Round((Drv.TotalSize - Drv.FreeSpace) / (1024 ^ 3), 1) & " GB"
			Dpct  = FormatPercent(Drv.FreeSpace / Drv.TotalSize, 1)
			Dinfo = Dinfo & vbLF & vbTAB & "Drive " & Drv.DriveLetter & ": " & vbTAB & "Total Size: " & vbTAB & Dtot & _
					vbLF & vbTAB 					& vbTAB & "Free Space: "   & vbTAB & Dfree & _
					vbLF & vbTAB 					& vbTAB & "Used Space: "   & vbTAB & Dused & _
					vbLF & vbTAB 					& vbTAB & "Percent Free: " & vbTAB & Dpct  & _
					vbLF & vbTAB 					& vbTAB & " "             & vbTAB & " "
		Case 4:	If Drv.IsReady Then
				If Drv.VolumeName = "" Then
					Dname = "No Name"
				Else
					Dname = Drv.VolumeName
				End If
			Else
				Dname = "No Media in CD-Rom"
			End If
			Dinfo = Dinfo & vbLF & vbTAB & "Drive " & Drv.DriveLetter & ": " & vbTAB & "CD/DVD-Rom" & vbTAB & Dname & _
					vbLF & vbTAB 					& vbTAB & " "          & vbTAB & " "
		End Select
Next

Set objFSO = Nothing


'-------------------------------------------------------
'- UpTime Info -----------------------------------------
'-------------------------------------------------------
For Each OSObject In GetObject ("winmgmts:").InstancesOf ("Win32_OperatingSystem")
	Bootup         = OSObject.LastBootUpTime
	LastBootupTime = PC_DateStringToDate(Bootup)
	SystemUptime   = DateDiff("h", LastBootUpTime, Now)
	Dinfo          = Dinfo & vbLF & vbTAB & "PC: " & vbTAB & "Boot Date: "  & vbTAB & LastBootupTime & _
	                         vbLF & vbTAB 	      & vbTAB & "PC Up Time: " & vbTAB & SystemUpTime & " Hour"
Next

HouseBotStartTime   = GetPropertyValue ("PC Info.HouseBot Start Time")
HouseBotUpTime      = DateDiff("h", HouseBotStartTime, Now)
Dinfo               = Dinfo & vbLF & vbTAB & vbTAB & "HouseBot Up Time: " & vbTAB & HouseBotUpTime & " Hour"


'-------------------------------------------------------
'- Geheugen Info ---------------------------------------
'-------------------------------------------------------
For Each MemObject In GetObject ("winmgmts:").InstancesOf ("CIM_OperatingSystem")
'	FreePhysicalMem = MemObject.FreePhysicalMemory
	FreePageMem     = MemObject.FreeSpaceInPagingFiles
Next

For Each MemObject In GetObject("winmgmts:").InstancesOf("Win32_LogicalMemoryConfiguration")
'	TotalPhysicalMem = MemObject.TotalPhysicalMemory
	TotalPageMem     = MemObject.TotalPageFileSpace
	UsedPageMem      = Round(((TotalpageMem - FreePageMem) / 1024), 0)
	Dinfo            = Dinfo & vbLF & vbTAB & vbTAB & "Memory Usage: " & vbTAB & UsedPageMem & " MB"
Next


'-------------------------------------------------------
'- IP and HostName Info --------------------------------
'-------------------------------------------------------
Set objRemXML   = CreateObject("Microsoft.XMLDOM")
objRemXML.async = False
objRemXML.load(cstrShowMyIP)

On Error Resume Next

If Err.Number = 0 Then
    Set objMyIP = objRemXML.selectSingleNode("/ip_address/ip")
    If Err.Number = 0 Then
        strIPAddress = objMyIP.text
        Set objMyIP  = objRemXML.selectSingleNode("/ip_address/host")
        If Err.Number = 0 Then
            strHostname = objMyIP.text
        Else
            strHostName = "No Hostname info"
        End If
    Else
        strIPAdress = "No IP info"
        strHostName = "No Hostname info"
    End If
Else
    strIPAdress = "No contact"
    strHostName = "No contact"
End If

Dinfo = Dinfo & vbLF & vbTAB & vbTAB & "IP Address: " & vbTAB & strIPAddress & _
		vbLF & vbTAB & vbTAB & "Hostname: " & vbTAB & strHostname
SetPropertyValue "PC Info.IP Address", strIPAddress
SetPropertyValue "PC Info.Host Name", strHostname
SetPropertyValue "PC Info.Memory Used", UsedPageMem & " MB"
SetPropertyValue "PC Info.Log PC Info", Dinfo

Set objMyIP   = Nothing
Set objRemXML = Nothing


'-------------------------------------------------------
'- Function: UpTime Info Format Date and Time ----------
'-------------------------------------------------------
Function PC_DateStringToDate(Bootup)
    If GetPropertyValue ("PC Info.Date Format") = "US" Then
        PC_DateStringToDate = CDate(Mid(Bootup, 5, 2) & "/" & Mid(Bootup, 7, 2) & "/" & Left(Bootup, 4) _
        & " " & Mid (Bootup, 9, 2) & ":" & Mid(Bootup, 11, 2) & ":" & Mid(Bootup, 13, 2))
    Else
        PC_DateStringToDate = CDate(Mid(Bootup, 7, 2) & "/" & Mid(Bootup, 5, 2) & "/" & Left(Bootup, 4) _
        & " " & Mid (Bootup, 9, 2) & ":" & Mid(Bootup, 11, 2) & ":" & Mid(Bootup, 13, 2))
    End If
End Function